import java.util.concurrent.TimeUnit;
import org.junit.*;
import static org.junit.Assert.*;
import org.openqa.selenium.*;
import org.openqa.selenium.firefox.FirefoxDriver;

public class PandoraTest {
	private WebDriver driver;
	private String baseUrl;
	private StringBuffer verificationErrors = new StringBuffer();
	
	public PandoraTest(WebDriver wd) throws Exception{
		driver=wd;
		setUp();
	}
	
	public PandoraTest() throws Exception{
		driver = new FirefoxDriver();
		setUp();
	}
	
	@Before
	public void setUp() throws Exception {
		baseUrl = "http://www.pandora.com";
		driver.manage().timeouts().implicitlyWait(30, TimeUnit.SECONDS);
	}

	@Test
	public void testPandora() throws Exception {
		driver.get(baseUrl + "/account/sign-in");
		for (int second = 0;; second++) {
			if (second >= 60) fail("timeout");
			try { if (isElementPresent(By.name("email"))) break; } catch (Exception e) {}
			Thread.sleep(1000);
		}

		driver.findElement(By.name("email")).clear();
		driver.findElement(By.name("email")).sendKeys("andrew.feeney@wpi.edu");
		driver.findElement(By.name("password")).clear();
		driver.findElement(By.name("password")).sendKeys("nopeNOPE");
		driver.findElement(By.xpath("//input[@value='Sign in']")).click();
		driver.findElement(By.cssSelector("span.user_activator")).click();
		driver.findElement(By.linkText("Sign out")).click();
	}

	@After
	public void tearDown() throws Exception {
		driver.quit();
		String verificationErrorString = verificationErrors.toString();
		if (!"".equals(verificationErrorString)) {
			fail(verificationErrorString);
		}
	}

	private boolean isElementPresent(By by) {
		try {
			driver.findElement(by);
			return true;
		} catch (NoSuchElementException e) {
			return false;
		}
	}
}
